/* IP/tcp_port Redirector Redirect data from source A to dest C via B (this
 * host), thus overiding routing path in application layer. 
 * This works like a  proxy www server, but it works for any port/application.
 * 
 * Program tested under sunos 5.x Can support MAXCHILDS connections to the same
 * host simultaneously. forks a new process for every connection.
 * 
 * Change MAXCHILDS as you wish. 
 */

#define  MAXCHILDS 30

#include <sys/types.h>
#include <sys/time.h>
#include <sys/wait.h>
#include <sys/socket.h>

#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <poll.h>


#include <stropts.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>
#include <signal.h>
#include <stdio.h>
#include <strings.h>
#include <stdlib.h>


void            childhdl(int);
void            newdest();
void            connectC(char *, char *);
char            buffer[100000];
int             lsd, b,r, i, Asd, Csd, len, we_full, we_child, cdown;
int             reconfigurable,proxymode, Confsd, rConfsd;
char            desthost[64], destport[10];
struct sockaddr_in sa, sc, sconf;
unsigned char   in[2];
struct timeval  tval;
struct hostent *chost;
fd_set          inout_fds;

char		*badsites[1024];
int		numofsites=0;
int 		mypid=0;

void
readsites(char *filename)
{
  FILE *fp;
  char buff[256];
  
  if (!(fp=fopen(filename,"r"))) {
    perror(filename);
    exit(errno);
  }
  
  numofsites=0;
  while (fgets(buff,255,fp)) {
    buff[strlen(buff)-1]=0;
    badsites[numofsites]=(char*)malloc(strlen(buff));
    strcpy(badsites[numofsites],buff);

#ifdef DEBUG
    printf("Added:%s\n",buff);
#endif

    numofsites++;
  }
}

int
main(int argc, char *argv[])
{
  int             one = 1;

  Asd = -1;
  Csd = -1;
  Confsd = -1;
  we_full = 0;
  we_child = 0;
  reconfigurable = 0;
  proxymode = 0;
  cdown = 1;


  if (argc < 4) {
    printf("\nIpRedirectd version 0.3 , Spiros Ioannou 1999\n");
    printf("Usage: ipredirect localport desthost destport\n\tor\n");
    printf("       ipredirect localport  \"rec\"   confport\n\tor\n");
    printf("       ipredirect localport proxyhost proxyport \"noad\"\n\n");
    printf("The 'rec' parameter specifies a configuration port.\n");
    printf("destport is specified by conecting to confport\n\n");
    printf("When the 'noad' parameter is used, the program forwards\n");
    printf("connections to destport as in the first case, but it cuts\n");
    printf("out urls in the 'site.bad' file (banners). In this case'\n");
    printf("desthost/port should be a proxy server\n\n");
    exit(-1);
  }
  else if (!strcmp(argv[2], "rec"))
    reconfigurable = 1;
  else if (argc==5 && !strcmp(argv[4],"noad")) {
    proxymode=1;
    readsites("sites.bad");
  }

  printf("Maximum servers:%d\n",MAXCHILDS);

  if (reconfigurable) {
    printf("Running in reconfigurable mode, connect to \n");
    printf("confport %d to specify new destination address\n", atoi(argv[3]));
  }

  if (proxymode) {
    printf("Running in noads proxy mode.\n");
  }

  signal(SIGCHLD, childhdl);
  /*signal(SIGCHLD, SIG_IGN);*/


  if (reconfigurable) {

    if ((Confsd = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
      perror("conf:socket");
      exit(errno);
    }
    setsockopt(Confsd, SOL_SOCKET, SO_REUSEADDR, (char *) &one, sizeof(one));
    sconf.sin_family = AF_INET;
    sconf.sin_port = htons((u_short) atoi(argv[3]));
    sconf.sin_addr.s_addr = htonl(INADDR_ANY);

    if (bind(Confsd, (struct sockaddr *) & sconf, sizeof(sconf)) < 0) {
      perror("conf:bind");
      exit(errno);
    }

    if (listen(Confsd, 1) < 0) {
      perror("conf:listen");
      exit(errno);
    }
    len = sizeof(sconf);
    printf("\nConfiguration port ready ... awaiting for connection\n");
  }
  else {

    strcpy(desthost, argv[2]);
    strcpy(destport, argv[3]);
  }


  if (reconfigurable) {
    if ((rConfsd = accept(Confsd, (struct sockaddr *) & sconf, &len)) < 0) {
      perror("rConfsd:accept");
      exit(4);
    }
    else {
      strcpy(buffer, "\nWelcome to ipredirector\n-----------------------\n");
      strcat(buffer, "Please specify a destination host after each prompt in\n");
      strcat(buffer, "the form : host port\nType help for help, or exit to quit\n\n");
      strcat(buffer, "Destination > ");
      write(rConfsd, buffer, strlen(buffer));
      newdest();
    }
  }


  /* Open  the "listening"  socket */

  if ((lsd = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
    perror("lsd:socket");
    exit(1);
  }
  setsockopt(lsd, SOL_SOCKET, SO_REUSEADDR, (char *) &one, sizeof(one));
  sa.sin_family = AF_INET;
  sa.sin_port = htons((u_short) atoi(argv[1]));
  sa.sin_addr.s_addr = htonl(INADDR_ANY);

  if (bind(lsd, (struct sockaddr *) & sa, sizeof(sa)) < 0) {
    perror("lsd:bind");
    exit(errno);
  }

  if (listen(lsd, 10) < 0) {
    perror("lsd:listen");
    exit(errno);
  }
  len = sizeof(sa);
  strcpy(buffer, "");
  printf("daemon ready ...\n");


  while (1) {
    fflush(stdout);
    tval.tv_sec = 0;
    tval.tv_usec = 0;		/* 50 microseconds */

startselect:

    FD_ZERO(&inout_fds);	/* Initialize file descriptors for select */

    /* Prepare for input from host A */
    if (we_child && Asd > 0)
      FD_SET(Asd, &inout_fds);

    /* Prepare for input from host C */
    if (we_child && Csd > 0)
      FD_SET(Csd, &inout_fds);


    /* Prepare to accept a connection to our socket */

    if (!we_child)
      FD_SET(lsd, &inout_fds);

    if (!we_child && reconfigurable)
      FD_SET(rConfsd, &inout_fds);


#ifdef DEBUG
    printf("%d:before select.. we_child:%d\n",mypid, we_child);
#endif

    /* Do a non-timeout select (interupt driven) to minimize load */
    do {
      i = select(64, &inout_fds, (fd_set *) 0, (fd_set *) 0,
		 (struct timeval *) 0 /* &tval */ );

#ifdef DEBUG
      if (i == EINTR)
	printf("%d:Select probably interrupted by SIGCHLD signal\n",mypid);
#endif
    } while (i == EINTR || i < 0);

#ifdef DEBUG
    printf("%d:after select=%d..we_child:%d\n",mypid, i, we_child);
#endif

    if (FD_ISSET(rConfsd, &inout_fds)) {
      newdest();
      printf("New destination is: %s %s\n", desthost, destport);
    }

    /* We are server, and full,and a new connection */

    if (FD_ISSET(lsd, &inout_fds) && we_full >= MAXCHILDS && !we_child) {
      if ((Asd = accept(lsd, (struct sockaddr *) & sa, &len)) < 0) {
	perror("Asd:000:accept");
      }
      else {
	/* deny connection */

#ifdef DEBUG
	printf("%d:Rejected new connection -- server full,%d\n",mypid, Asd);
	printf("Family=:%d , port=%d address: %s\n",
	       sa.sin_family, ntohs(sa.sin_port), inet_ntoa(sa.sin_addr));
#endif

	strcpy(buffer, "\nServer full, sorry ;-).\n");
	write(Asd, buffer, sizeof(buffer));
	shutdown(Asd, 2);
	close(Asd);
	Asd = -1;
      }
    }
    /* A new connection, ... */
    else if (FD_ISSET(lsd, &inout_fds) && we_full < MAXCHILDS && !we_child) {

      if (!fork()) {
	mypid=getpid();
#ifdef DEBUG
	printf("Child %ld is born\n",mypid);
#endif

	we_child = 1;
	we_full = 0;
	if ((Asd = accept(lsd, (struct sockaddr *) & sa, &len)) < 0) {
	  perror("child accept Asd");
	  exit(6);
	}
#ifdef DEBUG
	printf("%d:A new connection from address: %s port=%d \n",mypid,
	       inet_ntoa(sa.sin_addr), ntohs(sa.sin_port));
#endif
	close(lsd);

#ifdef ALLDEBUG
	strcpy(buffer, "\nServer welcomes you.\n");
	write(Asd, buffer, sizeof(buffer));
#endif

	connectC(desthost, destport);
	goto startselect;
      }
      else {
	we_full++;
      }
    }

    /* transfer data from A to C */
    if (we_child && Asd > 0 && FD_ISSET(Asd, &inout_fds)) {
      bzero(buffer, sizeof(buffer));

      /* read data from A */
      b = read(Asd, buffer, sizeof(buffer));

#ifdef ALLDEBUG
      printf("buffer read from A is:#%s#=%d bytes\n",
	     buffer, b);
#endif

      /* If read failed : A closed connection */
      if (b <= 0) {
	/* Free A for a new connection */

	shutdown(Asd, 2);
	close(Asd);

	/* Close C also to establish new connection in a fresh manner */
	shutdown(Csd, 2);
	close(Csd);
	Csd = -1;
#ifdef DEBUG
	printf("%d:Closed connection to  address: %s port=%d \n",mypid,
	       inet_ntoa(sa.sin_addr), ntohs(sa.sin_port));
#endif


#ifdef DEBUG
	printf("pid %d:quiting, A closed connection \n", getpid());
#endif
	exit(0);
      }
      else {

#ifdef ALLDEBUG
	printf("\nbuffer written to C is:#%s#=%d bytes\n",
	       buffer, b);
#endif

	
	if (proxymode) {
	  if (!strncasecmp(buffer,"GET http://",11)) {

	    for (i=0;i<numofsites;i++) {
	      if (!strncmp(buffer+11,badsites[i],
		    strlen(badsites[i]))) {
#ifdef DEBUG
		printf("Detected bad:%s\n",badsites[i]);
#endif
		strcpy(buffer,"GET http://www.softlab.ece.ntua.gr/"
		    "~sivann/images/ad.gif HTTP/1.0\n"
		    "Connection: close\n"
		    "Host: www.softlab.ece.ntua.gr\n\n");
	      }
	    }
	    

	  }
	      
	}

	/* write A data to C */
	write(Csd, buffer, b);

#ifdef  DEBUG
	printf("%d:001:A to C: #%s#\n",mypid, buffer);
#endif
      }
    }
    /* Transfer data from C to A */
    if (we_child && Csd > 0 && FD_ISSET(Csd, &inout_fds) && Asd > 0) {
      bzero(buffer, sizeof(buffer));

#ifdef DEBUG
      printf("%d:Reading from C...",mypid);
#endif

      /* read data from C */
      b = read(Csd, buffer, sizeof(buffer));

#ifdef DEBUG
      printf("%d:Ok, read %d bytes\n",mypid, b);
#endif

#ifdef ALLDEBUG
      printf("buffer read from C is:#%s#=%d bytes\n",
	     buffer, b);
#endif

      if (b <= 0) {
	/* C closed connection */
	shutdown(Csd, 2);
	close(Csd);
	Csd = -1;

	/* Tell A nothing more to hope for */
	shutdown(Asd, 2);
	close(Asd);
	Asd = -1;
#ifdef DEBUG
	printf("%d:Closed connection :   address: %s port=%d \n",mypid,
	       inet_ntoa(sa.sin_addr), ntohs(sa.sin_port));
#endif

#ifdef DEBUG
	printf("pid %d:quiting, C closed connection \n", mypid);
#endif
	exit(0);
      }
      else {

#ifdef ALLDEBUG
	printf("\nbuffer written to A is:#%s#=%d bytes\n",
	       buffer, b);
#endif

#ifdef DEBUG
	printf("%d:Writing to A...",mypid);
#endif

	/* Write data to A */
	r=write(Asd, &buffer, b);

#ifdef DEBUG
      printf("%d:Ok, written %d bytes\n",mypid, r);
#endif

#ifdef DEBUG
	printf("002:C to A: #%s#\n", buffer);
#endif

#ifdef DEBUG
	printf("%d:Ok...\n",mypid);
#endif
      }
    }

  }
  return 0;
}				/* End of main */


void 
connectC(char *host, char *port)
{

  /* Open C socket and connect to C host */

  if ((Csd = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
    perror("Can't open C socket");
    exit(-2);
  }
  sc.sin_port = htons((u_short) atoi(port));

  if (!(chost = gethostbyname(host))) {
      fprintf(stderr,"Host not found\n");
      exit(errno);
  }

#ifdef DEBUG
  printf("\nC address : %s %d \n", (chost->h_name),
	 ntohs(sc.sin_port));
#endif

  sc.sin_family = AF_INET;
  memcpy(&sc.sin_addr, chost->h_addr, chost->h_length);

  if (connect(Csd, (struct sockaddr *) & sc, sizeof(sc)) < 0) {
    perror("Can't connect to C");
    exit(-3);
  }

#ifdef DEBUG
  else
    printf("%d:Connected to C\n",mypid);
#endif

  cdown = 0;
}

int 
my_usleep(x)
{
  struct timeval  time;

  int             r;

  time.tv_sec = x / 1000000;
  time.tv_usec = x % 1000000;
  r = select(0, NULL, NULL, NULL, &time);
  return r;
}

void 
childhdl(int pid)
{
  int i,r;

  while((r=waitpid(-1,&i,WNOHANG))>0) 
    we_full--;

#ifdef DEBUG
  printf("\n%d:Inside childhandler,child %d died,we_full isnow:%d \n",getpid(),
      r, we_full);
#endif

  signal(SIGCHLD, childhdl);

}

void 
newdest()
{
  int             c;

  bzero(buffer, sizeof(buffer));
  c = read(rConfsd, buffer, sizeof(buffer));
  if (c <= 0) {
    printf("Configuration port closed,shuting down\n");
    if (Asd > 0)
      shutdown(Asd, 2);
    if (Csd > 0)
      shutdown(Csd, 2);
    shutdown(Confsd, 2);
    close(Asd);
    close(Csd);
    close(Confsd);
    exit(5);
  }
  else
    buffer[c] = '\0';
  sscanf(buffer, "%s%s", desthost, destport);

  if (!strcmp(desthost, "help")) {
    strcpy(buffer, "\nJust type hostname and port, i.e. \"www.sun.com 80\"\n");
    strcat(buffer, "or type \"exit\" to exit\n\n");
  }
  else if (!strcmp(desthost, "exit")) {
    printf("Configuration port requested exit,shuting down\n");
    if (Asd > 0)
      shutdown(Asd, 2);
    if (Csd > 0)
      shutdown(Csd, 2);
    shutdown(Confsd, 2);
    close(Asd);
    close(Csd);
    close(Confsd);
    exit(5);
  }
  else
    sprintf(buffer, "\nDestination host: %s\nDestination port:%s\n",
	    desthost, destport);

  strcat(buffer, "\nDestination > ");
  write(rConfsd, buffer, strlen(buffer));
}
